package com.nisum.learning.student.service;

import com.nisum.learning.student.model.Student;
import com.nisum.learning.student.repository.StudentRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

@Service
public class StudentService {
    @Autowired
    StudentRepository<Student, Integer> studentRepository;

    public Flux<Student> findAll() {
        return studentRepository.findAll();
    }

    public Mono<Student> findById(Integer id){
        return studentRepository.findById(id);
    }

    public void create(Student newStudent){
        studentRepository.save(newStudent).subscribe();
    }

    public Mono<Student> update(Student newStudent){
        return studentRepository.save(newStudent);
    }

    public void deleteById(int id){
        studentRepository.deleteById(id);
    }
}
